/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the HubspotControllerActionObjectRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &HubspotControllerActionObjectRequest{}

// HubspotControllerActionObjectRequest struct for HubspotControllerActionObjectRequest
type HubspotControllerActionObjectRequest struct {
	OAuthId *string `json:"oAuthId,omitempty"`
}

// NewHubspotControllerActionObjectRequest instantiates a new HubspotControllerActionObjectRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewHubspotControllerActionObjectRequest() *HubspotControllerActionObjectRequest {
	this := HubspotControllerActionObjectRequest{}
	return &this
}

// NewHubspotControllerActionObjectRequestWithDefaults instantiates a new HubspotControllerActionObjectRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewHubspotControllerActionObjectRequestWithDefaults() *HubspotControllerActionObjectRequest {
	this := HubspotControllerActionObjectRequest{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *HubspotControllerActionObjectRequest) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *HubspotControllerActionObjectRequest) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *HubspotControllerActionObjectRequest) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *HubspotControllerActionObjectRequest) SetOAuthId(v string) {
	o.OAuthId = &v
}

func (o HubspotControllerActionObjectRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o HubspotControllerActionObjectRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	return toSerialize, nil
}

type NullableHubspotControllerActionObjectRequest struct {
	value *HubspotControllerActionObjectRequest
	isSet bool
}

func (v NullableHubspotControllerActionObjectRequest) Get() *HubspotControllerActionObjectRequest {
	return v.value
}

func (v *NullableHubspotControllerActionObjectRequest) Set(val *HubspotControllerActionObjectRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableHubspotControllerActionObjectRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableHubspotControllerActionObjectRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableHubspotControllerActionObjectRequest(val *HubspotControllerActionObjectRequest) *NullableHubspotControllerActionObjectRequest {
	return &NullableHubspotControllerActionObjectRequest{value: val, isSet: true}
}

func (v NullableHubspotControllerActionObjectRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableHubspotControllerActionObjectRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
